import BusX
import Combine
import SwiftUI

extension Cord {
  public final class TextField: ObservableObject {
    @Published public var value = "a:"
    var subscriptions = [AnyCancellable]()
   
    public init(
      _ textApp: String,
      _ textUI: String
    ) {
      Bus.send(
        textUI,
        $value
          .removeDuplicates()
          .compactMap(onlyUIText)
          .eraseToAnyPublisher(),
        sub: &subscriptions
      )
   
      Bus.receive(
        [textApp],
        { [weak self] (_, v: String) in self?.value = "a:\(v)" },
        sub: &subscriptions
      )
    }
  }
}
